.\" t
.\" @(#)Save.1	12/10/94
.TH Save 1.8 "Feb 7 2000" Save
.UC
.SH NAME
\fBSave\fP \- the AfterStep desktop-layout saving module

.SH SYNOPSIS
\fBSave\fP [\-f \fIconfig_file\fP] [\-v | \--version] [\-h | \--help]
.sp
Although \fBSave\fP can be run from the command line, it is normally 
spawned by afterstep from within an afterstep menu file by 'Save':
.nf
.sp
% cat "~/GNUstep/Library/AfterStep/start/Modules/Save"
	Module "Save" Save
	MiniPixmap "mini-as.xpm"
.fi

.SH DESCRIPTION
When called, this module will attempt to save your current desktop
layout into a file called .xinitrc.
Usually, you will have to edit it to get a useable configuration, so be sure to
keep a backup of your old .xinitrc.
 
Your applications must supply certain hints to the X window system.
Emacs, for example, does not, so Save can't get any information from it.  
 
Also, Save assumes that certain command line options are
globally accepted by applications, which may not be the case.

AND DON'T FORGET AFTERSTEP ALREADY SAVES DESKTOP INTO
~/GNUstep/Library/AfterStep/.workspace_state file, called from autoexec !

Using both Save and AfterStep default saving will save twice the same window,
therefore open it twice on next startup !

.SH OPTIONS
.IP "\-f \fIconfig_file\fP"
Use \fIconfig_file\fP instead of the default configuration file.

.IP "\-h | \--help"
Print a usage message and exit successfully.

.IP "\-v | \--version"
Print version information and exit successfully.

.SH INITIALIZATION
During initialization, \fISave\fP will eventually search a configuration 
file which describes the time-outs and actions to take.  This file 
will be the one specified by the \fI\-f\fP option (if given).  Else, the 
~/GNUstep/Library/AfterStep/save file will be used if it exists.  Else, 
/usr/local/share/afterstep/save will be used.

.SH INVOCATION
Save can be invoked by inserting the line 'Save' in
"~/GNUstep/Library/AfterStep/start/Modules/Save desktop" file.
It can be bound to a menu or mouse button or keystroke in feel file to invoke
it later.
AfterStep will search directory specified in the ModulePath configuration
option to attempt to locate Save.

.SH CONFIGURATION OPTIONS
Sorry, but there is none at the moment.
Moreover, which options could be useful ?

.SH AUTHORS
Per Persson <pp@solace.mh.se>
.nf
Robert Nation
.nf
David Mihm <dmihm@swbell.net> [Man page]

.SH SEE ALSO
.BR afterstep (1)
